{

raVen's outbound processor
(c) 2000 by raVen

supported compilers: borland pascal 7.0, virtual pascal 2.0b+

}
{&Use32+,LocInfo+}
{$D+,L+,I-,R-,S-,Q-}
{}
Unit rFtnOut;
interface
Uses Objects, rObjects, Dos, rAbs;
{}
const
 PktMask: pChar = '*.pkt';
{}
type
{}
 tOutFlavor = (ofNormal, ofCrash, ofDirect, ofHold, ofImmediate);
 tFileType = (ftNone, ftKillSent, ftTruncateSent);
 tOutType = (otTShortBox, otTLongBox, otLongBox, otBSO, otBrakeLongBox, otLongBSO);
{( tLink )}
 pLink = ^tLink;
 tLink = object(tObject)
  Address: pString;
  Flavor: tOutFlavor;
  constructor Init(const aAddress: String; aFlavor: tOutFlavor);
  destructor  Done; virtual;
 end;
{( tLinkFile )}
 pLinkFile = ^tLinkFile;
 tLinkFile = object(tObject)
  FileDir,FileName: pString;
  Attr: Byte;
  Time, Size: Longint;
  FileType: tFileType;
  constructor Init(const aFileDir: String; const asr: SearchRec; aFileType: tFileType);
  destructor  Done; virtual;
 end;
{( tLinkCollection )}
 pLinkCollection = ^tLinkCollection;
 tLinkCollection = object(tSortedCollection)
  function Compare(Key1, Key2: Pointer): Integer; virtual;
 end;
{( tLinkFileCollection )}
 pLinkFileCollection = ^tLinkFileCollection;
 tLinkFileCollection = object(tSortedCollection)
  function Compare(Key1, Key2: Pointer): Integer; virtual;
 end;
{( tDomainInfo )}
 pDomainInfo = ^tDomainInfo;
 tDomainInfo = object(tObject)
  Zone: Integer;
  Domain: pString;
  constructor Init(const aZone: Integer; const aDomain: String);
  destructor  Done; virtual;
 end;
{( tDomainInfoCollection )}
 pDomainInfoCollection = ^tDomainInfoCollection;
 tDomainInfoCollection = object(tSortedCollection)
  function Compare(Key1, Key2: Pointer): Integer; virtual;
 end;
{( tOutBound )}
 pOutBound = ^tOutBound;
 tOutBound = object(tObject)
  RootDir: pString;
  LinkError: Boolean;
  FileError: Boolean;
  hVer,lVer: Word;
  FSCProd: Longint;
  ZoneDomains: pDomainInfoCollection;
  constructor Init(const aRootDir: String);
  destructor  Done; virtual;

  procedure GetLinks(var Links: tLinkCollection); virtual;
  procedure GetFiles(var Link: tLink; var Files: tLinkFileCollection); virtual;

  procedure CopyFile(const Address,FileName: String; const Flavor: tOutFlavor); virtual;
  procedure MoveFile(const Address,FileName: String; const Flavor: tOutFlavor); virtual;

  procedure Name2Addr(const FileName: String; var Address: String; var Flavor: tOutFlavor); virtual;
  procedure Addr2Name(const Address: String; const Flavor: tOutFlavor; var FileName: String); virtual;

  function StoreMessage(const Address, SourceAddress, Password: String;
                         var Msg: tAbsMsg; const PktCutSize: Longint;
                         const Flavor: tOutFlavor): Byte; virtual;
  function LinkBusy(const Addr: String): Boolean; virtual;
  procedure SetDomain(const Zones, Domain: String);

  function AddFreq(const Addr,FileName: String): Byte; virtual;

  procedure CleanQueue; virtual;
end;
{( tAbsFileBoxes )}
 pAbsFileBoxes = ^tAbsFileBoxes;
 tAbsFileBoxes = object(tOutBound)
  procedure GetLinks(var Links: tLinkCollection); virtual;
  procedure GetFiles(var Link: tLink; var Files: tLinkFileCollection); virtual;
  procedure CopyFile(const Addr,FileName: String; const Flavor: tOutFlavor); virtual;
  procedure MoveFile(const Addr,FileName: String; const Flavor: tOutFlavor); virtual;
  function StoreMessage(const Address, SourceAddress, Password: String;
                         var Msg: tAbsMsg; const PktCutSize: Longint;
                         const Flavor: tOutFlavor): Byte; virtual;
 end;
{( tTLongBoxes )}
 pTLongBoxes = ^tTLongBoxes;
 tTLongBoxes = object(tAbsFileBoxes)
  procedure Name2Addr(const FileName: String; var Address: String; var Flavor: tOutFlavor); virtual;
  procedure Addr2Name(const Address: String; const Flavor: tOutFlavor; var FileName: String); virtual;
 end;
{( tTShortBoxes )}
 pTShortBoxes = ^tTShortBoxes;
 tTShortBoxes = object(tAbsFileBoxes)
  procedure Name2Addr(const FileName: String; var Address: String; var Flavor: tOutFlavor); virtual;
  procedure Addr2Name(const Address: String; const Flavor: tOutFlavor; var FileName: String); virtual;
 end;
{( tLongBoxes )}
 pLongBoxes = ^tLongBoxes;
 tLongBoxes = object(tAbsFileBoxes)
  procedure Name2Addr(const FileName: String; var Address: String; var Flavor: tOutFlavor); virtual;
  procedure Addr2Name(const Address: String; const Flavor: tOutFlavor; var FileName: String); virtual;
 end;
{( tLongBoxes )}
 pBrakeLongBoxes = ^tBrakeLongBoxes;
 tBrakeLongBoxes = object(tAbsFileBoxes)
  procedure Name2Addr(const FileName: String; var Address: String; var Flavor: tOutFlavor); virtual;
  procedure Addr2Name(const Address: String; const Flavor: tOutFlavor; var FileName: String); virtual;
 end;
{( tBSO )}
 pBSO = ^tBSO;
 tBSO = object(tOutBound)
  MainZone: Word;
  constructor Init(const aRootDir: String; const aMainZone: Word);
  destructor Done; virtual;
  procedure GetLinks(var Links: tLinkCollection); virtual;
  procedure GetFiles(var Link: tLink; var Files: tLinkFileCollection); virtual;
  procedure Name2Addr(const FileName: String; var Address: String; var Flavor: tOutFlavor); virtual;
  procedure Addr2Name(const Address: String; const Flavor: tOutFlavor; var FileName: String); virtual;
  procedure CopyFile(const Address,FileName: String; const Flavor: tOutFlavor); virtual;
  procedure MoveFile(const Address,FileName: String; const Flavor: tOutFlavor); virtual;
  procedure AttachFile(const Address,FileName: String; const Flavor: tOutFlavor; const FileType: tFileType); virtual;
  procedure CleanQueue; virtual;
  function StoreMessage(const Address, SourceAddress, Password: String;
                         var Msg: tAbsMsg; const PktCutSize: Longint;
                         const Flavor: tOutFlavor): Byte; virtual;
  function LinkBusy(const Addr: String): Boolean; virtual;
  function AddFreq(const Addr,FileName: String): Byte; virtual;
 private
  LinkFile: pStream;
 end;
{( tLongBSO )}
 pLongBSO = ^tLongBSO;
 tLongBSO = object(tOutBound)
  constructor Init(const aRootDir: String);
  destructor Done; virtual;
  procedure GetLinks(var Links: tLinkCollection); virtual;
  procedure GetFiles(var Link: tLink; var Files: tLinkFileCollection); virtual;
  procedure Name2Addr(const FileName: String; var Address: String; var Flavor: tOutFlavor); virtual;
  procedure Addr2Name(const Address: String; const Flavor: tOutFlavor; var FileName: String); virtual;
  procedure CopyFile(const Address,FileName: String; const Flavor: tOutFlavor); virtual;
  procedure MoveFile(const Address,FileName: String; const Flavor: tOutFlavor); virtual;
  procedure AttachFile(const Address,FileName: String; const Flavor: tOutFlavor; const FileType: tFileType); virtual;
  procedure CleanQueue; virtual;
  function StoreMessage(const Address, SourceAddress, Password: String;
                         var Msg: tAbsMsg; const PktCutSize: Longint;
                         const Flavor: tOutFlavor): Byte; virtual;
  function LinkBusy(const Addr: String): Boolean; virtual;
  function AddFreq(const Addr,FileName: String): Byte; virtual;
 private
  LinkFile: pStream;
 end;
{}
implementation
Uses rStrings, rCommon, rFido, Strings, rOpen, rFidoMsg;
{( tLink )}
constructor tLink.Init;
 begin
  inherited Init;
  Address:=nil;
  ReallocStr(Address,aAddress);
  Flavor:=aFlavor;
 end;
{}
destructor  tLink.Done;
 begin
  ReallocStr(Address,'');
  inherited Done;
 end;
{( tLinkFile )}
constructor tLinkFile.Init;
 begin
  inherited Init;
  FileDir:=nil;
  FileName:=nil;
  Attr:=asr.Attr;
  Time:=asr.Time;
  Size:=asr.Size;
  ReallocStr(FileDir,AddBackSlash(aFileDir));
  ReallocStr(FileName,asr.Name);
  FileType:=aFileType;
 end;
{}
destructor  tLinkFile.Done;
 begin
  ReallocStr(FileDir,'');
  ReallocStr(FileName,'');
  inherited Done;
 end;
{( tLinkCollection )}
function tLinkCollection.Compare;
 var
  s1,s2: String;
 begin
  s1:=GetPS(pLink(Key1)^.Address);
  s2:=GetPS(pLink(Key2)^.Address);
  if (s1>s2) then Compare:=-1 else
  if (s1=s2) then Compare:=1 else
  if (s1<s2) then Compare:=1;
 end;
{( tLinkFileCollection )}
function tLinkFileCollection.Compare;
 var
  s1,s2: String;
 begin
  s1:=GetPS(pLinkFile(Key1)^.FileName);
  s2:=GetPS(pLinkFile(Key2)^.FileName);
  if (s1>s2) then Compare:=-1 else
  if (s1=s2) then Compare:=0 else
  if (s1<s2) then Compare:=1;
 end;
{( tDomainInfo )}
constructor tDomainInfo.Init;
 begin
  inherited Init;
  Zone:=aZone;
  Domain:=nil;
  ReallocStr(Domain,aDomain);
 end;
{}
destructor  tDomainInfo.Done;
 begin
  ReallocStr(Domain,'');
  inherited Done;
 end;
{( tDomainInfoCollection )}
function tDomainInfoCollection.Compare;
 var
  p1: pDomainInfo absolute Key1;
  p2: pDomainInfo absolute Key2;
 begin
  if (p1^.Zone>p2^.Zone) then Compare:=-1 else
  if (p1^.Zone=p2^.Zone) then Compare:=0 else
  if (p1^.Zone<p2^.Zone) then Compare:=1;
 end;
{( tOutBound )}
constructor tOutBound.Init;
 begin
  inherited Init;
  RootDir:=nil;
  ReallocStr(RootDir,AddBackSlash(fExpand(aRootDir)));
  LinkError:=False;
  FileError:=False;
  hVer:=0;
  lVer:=0;
  FSCProd:=$FE;
  New(ZoneDomains,Init(16,16));
 end;
{}
destructor  tOutBound.Done;
 begin
  ReallocStr(RootDir,'');
  DisposeObj(ZoneDomains);
  inherited Done;
 end;
{}
procedure tOutBound.GetLinks;
 begin
  Links.FreeAll;
 end;
{}
procedure tOutBound.GetFiles;
 begin
  Files.FreeAll;
 end;
{}
procedure tOutBound.Name2Addr;
 begin
  Address:='';
  Flavor:=ofNormal;
 end;
{}
procedure tOutBound.Addr2Name;
 begin
  FileName:='';
 end;
{}
procedure tOutBound.CopyFile;
 begin
  abstract;
 end;
{}
procedure tOutBound.MoveFile;
 begin
  abstract;
 end;
{}
function tOutBound.StoreMessage;
 begin
  abstract;
 end;
{}
function tOutBound.LinkBusy;
 begin
  LinkBusy:=False;
 end;
{}
procedure tOutBound.SetDomain;
 var
  i,x,l: Integer;
  p: pDomainInfo;
 begin
  l:=WordCount(Zones,[Comma]);
  for x:=1 to l do
   begin
    New(p,Init(CToN(ExtractWord(x,Zones,[Comma])),Domain));
    if (ZoneDomains^.Search(p,i)) then ZoneDomains^.AtFree(i);
    ZoneDomains^.Insert(p);
   end;
 end;
{}
function tOutBound.AddFreq;
 begin
 end;
{}
procedure tOutBound.CleanQueue;
 begin
 end;
{( tAbsFileBoxes )}
procedure tAbsFileBoxes.GetLinks;
 var
  sr: SearchRec;
  Address: String;
  Flavor: tOutFlavor;
 begin
  if (@Links=nil) then exit;
  inherited GetLinks(Links);
  FindFirst(GetPS(RootDir)+x_x,Directory shl 8 or AnyFile,sr);
  while (DosError=0) do
   begin
    while ((sr.Name=Point) or
           (sr.Name=Point+Point) or
           (sr.Attr and Directory=0)) and
           (DosError=0) do FindNext(sr);
    Name2Addr(sr.Name,Address,Flavor);
    Links.Insert(New(pLink,Init(Address,Flavor)));
    FindNext(sr);
   end;
{$IfDef VirtualPascal}
  FindClose(sr);
{$EndIf}
 end;
{}
procedure tAbsFileBoxes.GetFiles;
 var
  sr: SearchRec;
  s: String;
 begin
  if (@Files=nil) or (@Link=nil) then Exit;
  inherited GetFiles(Link,Files);
  Addr2Name(GetPS(Link.Address),Link.Flavor,s);
  FindFirst(AddBackSlash(GetPS(RootDir))+AddBackSlash(s)+x_x,AnyFile,sr);
  while (DosError=0) do
   begin
    while ((sr.Name=Point) or
           (sr.Name=Point+Point) or
           (sr.Attr and Directory<>0) or
           (sr.Attr and VolumeID<>0)) and
           (DosError=0) do FindNext(sr);
    Files.Insert(New(pLinkFile,Init(AddBackSlash(GetPS(RootDir))+AddBackSlash(s),sr,ftKillSent)));
    FindNext(sr);
   end;
{$IfDef VirtualPascal}
  FindClose(sr);
{$EndIf}
 end;
{}
procedure tAbsFileBoxes.CopyFile;
 var
  BoxName: String;
 begin
  if (not Exist(FileName)) then exit;
  Addr2Name(Addr,Flavor,BoxName);
  MkTree(AddBackSlash(GetPS(RootDir)+BoxName));
  rCommon.CopyFile(FileName,GetPS(RootDir)+AddBackSlash(BoxName)+JustFileName(FileName),false);
 end;
{}
procedure tAbsFileBoxes.MoveFile;
 var
  BoxName: String;
 begin
  if (not Exist(FileName)) then exit;
  Addr2Name(Addr,Flavor,BoxName);
  MkTree(AddBackSlash(GetPS(RootDir)+BoxName));
  rCommon.MoveFile(FileName,GetPS(RootDir)+AddBackSlash(BoxName)+JustFileName(FileName));
 end;
{}
function tAbsFileBoxes.StoreMessage;
 var
  BoxName: String;
  sr: SearchRec;
  Pkt: pPktBase;
 begin
  StoreMessage:=1;
  if (@Msg=nil) then exit;
  if (Msg.MsgStatus=msEmpty) then exit;
  Addr2Name(Address,Flavor,BoxName);
  BoxName:=AddBackSlash(GetPS(RootDir)+BoxName);
  MkTree(BoxName);
  FindFirst(BoxName+StrPas(PktMask),AnyFile,sr);
  if (PktCutSize<=0) and (DosError=0) and (not FileLocked(BoxName+sr.Name,stDenyAll)) then DosError:=1;
  while (DosError=0) do
   begin
    if (sr.Size<PktCutSize) and (not FileLocked(BoxName+sr.Name,stDenyAll)) then Break;
    FindNext(sr);
   end;
  if (DosError<>0) or (not Exist(BoxName+sr.Name)) or (SizeOfFile(BoxName+sr.Name)>PktCutSize)
  then BoxName:=CalcNotExistFileName(BoxName,StrPas(PktExt))
  else BoxName:=BoxName+sr.Name;

  New(Pkt,Init);
  Pkt^.PktHdr.PVMajOr:=hVer;
  Pkt^.PktHdr.PVMinor:=lVer;
  Pkt^.PktHdr.PrdCodL:=FSCProd;
  if Exist(BoxName) then
   begin
    ReallocStr(Pkt^.BaseFileName,BoxName);
    Pkt^.MainLink:=New(pBufStream,Init(GetPS(Pkt^.BaseFileName),stOpen,BlockSize));
    Pkt^.BaseStatus:=bsOpened;
   end;
  if Pkt^.BaseStatus<>bsOpened then with (Pkt^) do
   begin
    SetSourceAddress(SourceAddress);
    SetDestinationAddress(Address);
    SetPassword(Password);
    SaveBaseHdr(BoxName,stDenyNone);
   end;
  with Pkt^ do
   begin
    DisposeObj(Kills);
    DisposeObj(Coords);
    DisposeObj(MainLink);
   end;
  ReallocStr(Pkt^.BaseFileName,'');
  Dispose(Pkt,Dummy);
  FastPktSave(BoxName,Msg);
{$IfDef VirtualPascal}
  FindClose(sr);
{$EndIf}
  StoreMessage:=0;
 end;
{( tTLongBoxes )}
const
 fHold   = 'H';
 fDirect = 'D';
 fCrash  = 'C';
 fNormal = 'F';
procedure tTLongBoxes.Name2Addr;
 begin
  Address:=ExtractWord(1,FileName,[Point])+DualPoint+ExtractWord(2,FileName,[Point])+Slash+
          ExtractWord(3,FileName,[Point])+Point+ExtractWord(4,FileName,[Point]);
  Address:=TruncateAddr(Address);
  if (UpStr(ExtractWord(5,FileName,[Point]))=fHold) then Flavor:=ofHold else Flavor:=ofNormal;
 end;
{}
procedure tTLongBoxes.Addr2Name;
 begin
  FileName:=ExtractWord(1,Address,FidoChars)+Point+ExtractWord(2,Address,FidoChars)+Point+
            ExtractWord(3,Address,FidoChars)+Point;
  if (CToN(ExtractWord(4,Address,FidoChars))<>0) then FileName:=FileName+ExtractWord(4,Address,FidoChars)
  else FileName:=FileName+'0';
  case flavor of
   ofHold: FileName:=FileName+Point+fHold;
  end;
 end;
{( tTShortBoxes )}
procedure tTShortBoxes.Name2Addr;
 begin
  Address:=NToC(ToDec(FileName[1]+FileName[2],32))+DualPoint+
           NToC(ToDec(FileName[3]+FileName[4]+FileName[5],32))+Slash+
           NToC(ToDec(FileName[6]+FileName[7]+FileName[8],32))+Point+
           NToC(ToDec(FileName[10]+FileName[11],32));
  Address:=TruncateAddr(Address);
  if (UpCase(FileName[12])=fHold) then flavor:=ofHold else flavor:=ofNormal;
 end;
{}
procedure tTShortBoxes.Addr2Name;
 begin
  FileName:=FromDec(CToN(ExtractWord(1,Address,FidoChars)),32,2)+
            FromDec(CToN(ExtractWord(2,Address,FidoChars)),32,3)+
            FromDec(CToN(ExtractWord(3,Address,FidoChars)),32,3)+Point+
            FromDec(CToN(ExtractWord(4,Address,FidoChars)),32,2);
  case flavor of
   ofHold: FileName:=FileName+fHold;
  end;
 end;
{( tLongBoxes )}
procedure tLongBoxes.Name2Addr;
 var
  c: Char;
  s: String;
 begin
  Address:=ExtractWord(1,FileName,[Point])+DualPoint+ExtractWord(2,FileName,[Point])+Slash+
           ExtractWord(3,FileName,[Point])+Point+ExtractWord(4,FileName,[Point]);
  Address:=TruncateAddr(Address);
  s:=UpStr(ExtractWord(5,FileName,[Point]));
  c:=s[1];
  case c of
   fHold: flavor:=ofHold;
   fDirect: flavor:=ofDirect;
   fCrash: flavor:=ofCrash;
   fNormal: flavor:=ofNormal;
   else flavor:=ofNormal;
  end;
 end;
{}
procedure tLongBoxes.Addr2Name;
 begin
  FileName:=ExtractWord(1,Address,FidoChars)+Point+ExtractWord(2,Address,FidoChars)+Point+
            ExtractWord(3,Address,FidoChars)+Point;
  if (CToN(ExtractWord(4,Address,FidoChars))<>0) then FileName:=FileName+ExtractWord(4,Address,FidoChars)
  else FileName:=FileName+'0';
  FileName:=FileName+Point;
  case flavor of
   ofHold: FileName:=FileName+fHold;
   ofImmediate, ofDirect: FileName:=FileName+fDirect;
   ofCrash: FileName:=FileName+fCrash;
   ofNormal: FileName:=FileName+fNormal;
  end;
 end;
{( tLongBoxes )}
const
 bfHold: pChar = 'hold';
 bfDirect: pChar = 'direct';
 bfCrash: pChar  = 'crash';
 bfNormal: pChar = 'normal';
 bfImmediate: pChar = 'immediate';
 bfAsshole: pChar = 'asshole';
{}
procedure tBrakeLongBoxes.Name2Addr;
 var
  s: String;
 begin
  Address:=ExtractWord(2,FileName,[Point])+DualPoint+ExtractWord(3,FileName,[Point])+Slash+
           ExtractWord(4,FileName,[Point])+Point+ExtractWord(5,FileName,[Point]);
  Address:=TruncateAddr(Address)+Masyamba+ExtractWord(1,FileName,[Point]);
  s:=UpStr(ExtractWord(6,FileName,[Point]));
  if (s=UpStr(StrPas(bfHold))) then flavor:=ofHold else
  if (s=UpStr(StrPas(bfDirect))) then flavor:=ofDirect else
  if (s=UpStr(StrPas(bfCrash))) then flavor:=ofCrash else
  if (s=UpStr(StrPas(bfNormal))) then flavor:=ofNormal else
  if (s=UpStr(StrPas(bfImmediate))) then flavor:=ofImmediate;
 end;
{}
procedure tBrakeLongBoxes.Addr2Name;
 var
  di: pDomainInfo;
  i: Integer;
 begin
  FileName:=ExtractWord(1,Address,FidoChars)+Point+ExtractWord(2,Address,FidoChars)+Point+
            ExtractWord(3,Address,FidoChars)+Point;
  if (CToN(ExtractWord(4,Address,FidoChars))<>0) then FileName:=FileName+ExtractWord(4,Address,FidoChars)
  else FileName:=FileName+'0';
  FileName:=FileName+Point;
  case flavor of
   ofHold: FileName:=FileName+StrPas(bfHold);
   ofDirect: FileName:=FileName+StrPas(bfDirect);
   ofCrash: FileName:=FileName+StrPas(bfCrash);
   ofNormal: FileName:=FileName+StrPas(bfNormal);
   ofImmediate: FileName:=FileName+StrPas(bfImmediate);
  end;
  New(di,Init(CToN(ExtractWord(1,Address,FidoChars)),''));
  if (not ZoneDomains^.Search(di,i)) then
   begin
    FileName:=StrPas(bfAsshole)+Point+FileName;
    DisposeObj(di);
   end
  else
   begin
    DisposeObj(di);
    di:=ZoneDomains^.At(i);
    FileName:=GetPS(di^.Domain)+Point+FileName;
   end;
 end;
{( tBSO )}
constructor tBSO.Init;
 begin
  inherited Init(aRootDir);
  ReallocStr(RootDir,RemoveBackSlash(FExpand(aRootDir)));
  MainZone:=aMainZone;
  LinkFile:=nil;
 end;
{}
destructor tBSO.Done;
 begin
  inherited Done;
  DisposeObj(LinkFile);
 end;
{}
const
 dirQueue: pChar = 'Queue\';
 xlo: pChar = '*.?lo';
procedure tBSO.GetLinks;

 procedure FileDoer(const s: String);
  var
   Address: String;
   Flavor: tOutFlavor;
  begin
   Name2Addr(s,Address,Flavor);
   Links.Insert(New(pLink,Init(Address,Flavor)));
  end;

 procedure InOutBound(const Path: String);

  procedure InPnt(const Path: String);
   var
    sr: SearchRec;
   begin
    FindFirst(Path+StrPas(xlo),AnyFile,sr);
    while (DosError=0) do
     begin
      FileDoer(Path+sr.Name);
      FindNext(sr)
     end;
{$IfDef VirtualPascal}
    FindClose(sr);
{$EndIf}
   end;

  var
   sr: SearchRec;
  begin
   FindFirst(Path+'*.pnt',AnyFile,sr);
   while (DosError=0) do
    begin
     if (sr.Attr and Directory=Directory) then InPnt(Path+sr.Name+BackSlash);
     FindNext(sr);
    end;
{$IfDef VirtualPascal}
   FindClose(sr);
{$EndIf}
   FindFirst(Path+StrPas(xlo),AnyFile,sr);
   while (DosError=0) do
    begin
     FileDoer(Path+sr.Name);
     FindNext(sr)
    end;
{$IfDef VirtualPascal}
   FindClose(sr);
{$EndIf}
  end;

 var
  sr: SearchRec;
 begin
  if (@Links=nil) then exit;
  inherited GetLinks(Links);
  FindFirst(RemoveBackSlash(GetPS(RootDir))+Star,AnyFile,sr);
  while (DosError=0) do
   begin
    if (sr.Attr and Directory=Directory) then InOutBound(AddBackSlash(JustPathName(GetPS(RootDir)))+sr.Name+BackSlash);
    FindNext(sr);
   end;
{$IfDef VirtualPascal}
  FindClose(sr);
{$EndIf}
 end;
{}
procedure tBSO.GetFiles;
 var
  s,fn,tfn: String;
  f1,f2: pStream;
  ft: tFileType;
  sr: SearchRec;
  fd: String;
  lfile: pLinkFile;
  i: Integer;
 begin
  if (@Files=nil) or (@Link=nil) then Exit;
  inherited GetFiles(Link,Files);
  Addr2Name(GetPS(Link.Address),Link.Flavor,fn);
  if (not Exist(fn)) then exit;
  f1:=New(pBufStream,Init(fn,stOpenRead+stDenyWrite,BlockSize));
  tfn:=GetTempFileName;
  f2:=New(pBufStream,Init(tfn,stCreate+stDenyWrite,BlockSize));
  while (f1^.Status=stOk) do
   begin
    StreamReadLn(f1^,s);
    s:=Trim(s,SpaceChars);
    case UpCase(s[1]) of
     '#':
      begin
       Delete(s,1,1);
       ft:=ftTruncateSent;
      end;
     '^':
      begin
       Delete(s,1,1);
       ft:=ftKillSent;
      end;
     else ft:=ftNone;
     end;
    if (not Exist(s)) then continue else case ft of
     ftTruncateSent: StreamWriteLn(f2^,'#','');
     ftKillSent: StreamWriteLn(f2^,'^','');
    end;
    StreamWriteLn(f2^,s,cr+lf);
    FindFirst(s,AnyFile,sr);
    lfile:=New(pLinkFile,Init(AddBackSlash(JustPathName(s)),sr,ft));
    if (not Files.Search(lfile,i)) then Files.Insert(lfile) else DisposeObj(lfile);
{$IfDef VirtualPascal}
    FindClose(sr);
{$EndIf}
   end;
  f1^.Reset;
  DisposeObj(f1);
  DisposeObj(f2);
  rCommon.MoveFile(tfn,fn);
 end;
{}
const
 AttrA: Array[0..4] of Char = 'fcdhi';
 sLo: pChar = 'lo';
 sUt: pChar = 'ut';
{}
procedure tBSO.Name2Addr;
 var
  s,s1: String;
  c: Longint;
 begin
  s:=Copy(FileName,Length(GetPS(RootDir))+1,Length(FileName));
  Address:='';
  c:=1;
  if (s[1]=Point) then
   begin
    Address:=Address+NToC(ToDec(ExtractWord(1,s,[BackSlash,Point]),16));
    Inc(c);
   end
  else Address:=Address+NToC(MainZone);
  s1:=ExtractWord(c,s,[BackSlash,Point]);
  Inc(c);
  Address:=Address+DualPoint+NToC(ToDec(s1[1]+s1[2]+s1[3]+s1[4],16))+
           Slash+NToC(ToDec(s1[5]+s1[6]+s1[7]+s1[8],16));
  s1:=UpStr(ExtractWord(c,s,[BackSlash,Point]));
  Inc(c);
  if (s1='PNT') then
   begin
    Address:=Address+Point+NToC(ToDec(ExtractWord(c,s,[BackSlash,Point]),16));
    Inc(c);
    s1:=ExtractWord(c,s,[BackSlash,Point]);
    Inc(c);
   end;
  if (UpStr(s1[2]+s1[3])=UpStr(StrPas(sLo))) then case UpCase(s1[1]) of
   'F': Flavor:=ofNormal;
   'C': Flavor:=ofCrash;
   'D': Flavor:=ofDirect;
   'H': Flavor:=ofHold;
   'I': Flavor:=ofImmediate
  end else if (UpStr(s1[2]+s1[3])=UpStr(StrPas(sUt))) then case UpCase(s1[1]) of
   'O': Flavor:=ofNormal;
   'C': Flavor:=ofCrash;
   'D': Flavor:=ofDirect;
   'H': Flavor:=ofHold;
   'I': Flavor:=ofImmediate;
  end else Flavor:=ofNormal;
 end;
{}
procedure tBSO.Addr2Name;
 var
  Zone, Node, Net, Point: Word;
  s: String;
  c: Char;
 begin
  Zone:=0;
  Node:=0;
  Net:=0;
  Point:=0;
  c:=AttrA[Integer(Flavor)];
  Zone:=CToN(ExtractWord(1,Address,FidoChars));
  Net:=CToN(ExtractWord(2,Address,FidoChars));
  Node:=CToN(ExtractWord(3,Address,FidoChars));
  Point:=CToN(ExtractWord(4,Address,FidoChars));
  if Zone<>MainZone then
   begin
    s:=HexL(Zone);
    Delete(s,1,4);
    if s[1]<>'0' then
    s[0]:=#3
    else Delete(s,1,1);
    s:='.'+s;
   end else s:='';
  FileName:=GetPS(RootDir)+s+BackSlash;
  s:=HexL(Net);
  Delete(s,1,4);
  FileName:=FileName+s;
  s:=HexL(Node);
  Delete(s,1,4);
  FileName:=FileName+s;
  if Point<>0 then
   begin
    FileName:=FileName+'.pnt\'+HexL(Point)+'.'+c+StrPas(sLo);
   end else FileName:=FileName+'.'+c+StrPas(sLo);
 end;
{}
procedure tBSO.CopyFile;
 var
  queueDir,bsoName: String;
  f: pStream;
 begin
  if (not Exist(FileName)) then exit;
  Addr2Name(Address,Flavor,bsoName);
  MkTree(bsoName);
  queueDir:=AddBackSlash(JustPathName(RemoveBackSlash(GetPS(RootDir))))+StrPas(dirQueue);
  MkTree(queueDir);
  if (not Exist(queueDir+JustFileName(FileName))) then rCommon.CopyFile(FileName,queueDir+JustFileName(FileName),false);
  if (not Exist(bsoName)) then f:=New(pBufStream,Init(bsoName,stCreate or stDenyWrite ,BlockSize))
  else f:=New(pBufStream,Init(bsoName,stOpenWrite or stDenyWrite,BlockSize));
  f^.Seek(f^.GetSize);
  StreamWriteLn(f^,queueDir+JustFileName(FileName),cr+lf);
  DisposeObj(f);
 end;
{}
procedure tBSO.MoveFile;
 var
  queueDir,bsoName: String;
  f: pStream;
 begin
  if (not Exist(FileName)) then exit;
  Addr2Name(Address,Flavor,bsoName);
  MkTree(bsoName);
  queueDir:=AddBackSlash(JustPathName(RemoveBackSlash(GetPS(RootDir))))+StrPas(dirQueue);
  MkTree(queueDir);
  if (not Exist(queueDir+JustFileName(FileName))) then rCommon.MoveFile(FileName,queueDir+JustFileName(FileName))
  else KillFile(FileName);
  if (not Exist(bsoName)) then f:=New(pBufStream,Init(bsoName,stCreate or stDenyWrite ,BlockSize))
  else f:=New(pBufStream,Init(bsoName,stOpenWrite or stDenyWrite,BlockSize));
  f^.Seek(f^.GetSize);
  StreamWriteLn(f^,queueDir+JustFileName(FileName),cr+lf);
  DisposeObj(f);
 end;
{}
procedure tBSO.AttachFile;
 var
  bsoName: String;
  f: pStream;
 begin
  if (not Exist(FileName)) then exit;
  Addr2Name(Address,Flavor,bsoName);
  if (not Exist(bsoName)) then f:=New(pBufStream,Init(bsoName,stCreate or stDenyWrite ,BlockSize))
  else f:=New(pBufStream,Init(bsoName,stOpenWrite or stDenyWrite,BlockSize));
  f^.Seek(f^.GetSize);
  case FileType of
   ftKillSent: StreamWriteLn(f^,'^','');
   ftTruncateSent: StreamWriteLn(f^,'#','');
  end;
  StreamWriteLn(f^,FileName,cr+lf);
  DisposeObj(f);
 end;
{}
procedure tBSO.CleanQueue;
 var
  sr: SearchRec;
  Files: pStrLines;
  bsoFiles: pStringCollection;
  lc: pLinkCollection;
  fc: pLinkFileCollection;
  s,QueueDir: String;
  x,y,i: Integer;
 begin
  QueueDir:=AddBackSlash(JustPathName(GetPS(RootDir)))+StrPas(dirQueue);
  FindFirst(QueueDir+x_x,AnyFile,sr);
  while (DosError=0) and ((sr.Name=Point) or (sr.Name=Point+Point)) do Dos.FindNext(sr);
  New(Files,Init(16,16));
  while (DosError=0) do
   begin
    if ((sr.Attr and Directory)=0) and
       ((sr.Attr and VolumeID)=0) then Files^.Insert(NewStr(UpStr(sr.Name)));
    FindNext(sr);
   end;
  New(lc,Init(16,16));
  New(fc,Init(16,16));
  New(bsoFiles,Init(16,16));
  bsoFiles^.Duplicates:=False;
  GetLinks(lc^);
  with (lc^) do if (Count>0) then for x:=0 to Count-1 do
   begin
    GetFiles(pLink(At(x))^,fc^);
    with (fc^) do if (Count>0) then for y:=0 to Count-1 do
    with (pLinkFile(At(y))^) do if (UpStr(QueueDir)=UpStr(GetPS(FileDir))) then
     begin
      s:=UpStr(UpStr(GetPS(FileName)));
      if (not bsoFiles^.Search(@s,i)) then bsoFiles^.Insert(NewStr(s));
     end;
   end;
  with (Files^) do if (Count>0) then for x:=0 to Count-1 do if (not bsoFiles^.Search(At(x),y)) then
  KillFile(QueueDir+GetPS(At(x)));
{$IfDef VirtualPascal}
  FindClose(sr);
{$EndIf}

  DisposeObj(Files);
  DisposeObj(bsoFiles);
  DisposeObj(lc);
  DisposeObj(fc);
 end;
{}
function tBSO.StoreMessage;
 var
  bsoName: String;
  Pkt: pPktBase;
  x: Word;
 begin
  StoreMessage:=1;
  if (@Msg=nil) then exit;
  if (Msg.MsgStatus=msEmpty) then exit;
  Addr2Name(Address,Flavor,bsoName);
  bsoName:=ForceExtension(bsoName,bsoName[Length(BsoName)-2]+'ut');
  if (UpCase(bsoName[Length(BsoName)-2])='F') then bsoName[Length(BsoName)-2]:='o';

  New(Pkt,Init);
  Pkt^.PktHdr.PVMajOr:=hVer;
  Pkt^.PktHdr.PVMinor:=lVer;
  Pkt^.PktHdr.PrdCodL:=FSCProd;
  if Exist(bsoName) then
   begin
    ReallocStr(Pkt^.BaseFileName,bsoName);
    Pkt^.MainLink:=New(pBufStream,Init(GetPS(Pkt^.BaseFileName),stOpen,BlockSize));
    Pkt^.BaseStatus:=bsOpened;
   end;
  if Pkt^.BaseStatus<>bsOpened then with Pkt^ do
   begin
    SetSourceAddress(SourceAddress);
    SetDestinationAddress(Address);
    SetPassWord(Password);
    SaveBaseHdr(bsoName,stDenyNone);
   end;
  with Pkt^ do
   begin
    x:=pkt^.MainLink^.Status;
    DisposeObj(Kills);
    DisposeObj(Coords);
    DisposeObj(MainLink);
   end;
  ReallocStr(Pkt^.BaseFileName,'');
  Dispose(Pkt,Dummy);
  if (x<>0) then exit;
  FastPktSave(bsoName,Msg);
  StoreMessage:=0;
 end;
{}
function tBSO.LinkBusy;
 var
  bsoName: String;
 begin
  Addr2Name(Addr,ofCrash,bsoName);
  LinkBusy:=(Exist(ForceExtension(bsoName,'bsy')) or (Exist(ForceExtension(bsoName,'csy'))));
 end;
{}
function tBSO.AddFreq;
 var
  bsoName: String;
  t: Text;
 begin
  AddFreq:=1;
  Addr2Name(Addr,ofCrash,bsoName);
  bsoName:=ForceExtension(bsoName,'req');
  if (not MkTree(bsoName)) then exit;
  Assign(t,bsoName);
  if Exist(bsoName) then Append(t) else Rewrite(t);
  WriteLn(t,FileName);
  Close(t);
  AddFreq:=0;
 end;
{( tLongBSO )}
const
 lbsoMail: pChar = 'mail';
 lbsoList: pChar = 'list';
 lbsoBusy: pChar = 'busy';
 lbsoRequ: pChar = 'request';
 lbsoStat: pChar = 'status';
{}
constructor tLongBSO.Init;
 begin
  inherited Init(aRootDir);
  ReallocStr(RootDir,AddBackSlash(FExpand(aRootDir)));
  LinkFile:=nil;
 end;
{}
destructor tLongBSO.Done;
 begin
  inherited Done;
  DisposeObj(LinkFile);
 end;
{}
procedure tLongBSO.GetLinks;

 procedure FileDoer(const s: String);
  var
   Address: String;
   Flavor: tOutFlavor;
  begin
   Name2Addr(s,Address,Flavor);
   Links.Insert(New(pLink,Init(Address,Flavor)));
  end;
 var
  sr: SearchRec;
 begin
  if (@Links=nil) then exit;
  inherited GetLinks(Links);
  FindFirst(AddBackSlash(GetPS(RootDir))+x_x,AnyFile and not Directory and not VolumeID,sr);
  while (DosError=0) do
   begin
    FileDoer(AddBackSlash(JustPathName(GetPS(RootDir)))+sr.Name);
    FindNext(sr);
   end;
{$IfDef VirtualPascal}
  FindClose(sr);
{$EndIf}
 end;
{}
procedure tLongBSO.GetFiles;
 var
  s,fn,tfn: String;
  f1,f2: pStream;
  ft: tFileType;
  sr: SearchRec;
  fd: String;
  lfile: pLinkFile;
  i: Integer;
 begin
  if (@Files=nil) or (@Link=nil) then Exit;
  inherited GetFiles(Link,Files);
  Addr2Name(GetPS(Link.Address),Link.Flavor,fn);
  fn:=fn+Point+StrPas(lbsoList);
  if (not Exist(fn)) then exit;
  f1:=New(pBufStream,Init(fn,stOpenRead+stDenyWrite,BlockSize));
  tfn:=GetTempFileName;
  f2:=New(pBufStream,Init(tfn,stCreate+stDenyWrite,BlockSize));
  while (f1^.Status=stOk) do
   begin
    StreamReadLn(f1^,s);
    s:=Trim(s,SpaceChars);
    case UpCase(s[1]) of
     '#':
      begin
       Delete(s,1,1);
       ft:=ftTruncateSent;
      end;
     '^':
      begin
       Delete(s,1,1);
       ft:=ftKillSent;
      end;
     else ft:=ftNone;
     end;
    if (not Exist(s)) then continue else case ft of
     ftTruncateSent: StreamWriteLn(f2^,'#','');
     ftKillSent: StreamWriteLn(f2^,'^','');
    end;
    StreamWriteLn(f2^,s,cr+lf);
    FindFirst(s,AnyFile,sr);
    lfile:=New(pLinkFile,Init(AddBackSlash(JustPathName(s)),sr,ft));
    if (not Files.Search(lfile,i)) then Files.Insert(lfile) else DisposeObj(lfile);
{$IfDef VirtualPascal}
    FindClose(sr);
{$EndIf}
   end;
  f1^.Reset;
  DisposeObj(f1);
  DisposeObj(f2);
  rCommon.MoveFile(tfn,fn);
 end;
{}
procedure tLongBSO.Name2Addr;
 var
  s: String;
 begin
{  fidonet.2.6033.66.28.normal.mail}
  s:=FileName;
  Delete(s,1,Length(GetPS(RootDir)));
  Address:=ExtractWord(2,s,[Point])+DualPoint+ExtractWord(3,s,[Point])+Slash+
           ExtractWord(4,s,[Point])+Point+ExtractWord(5,s,[Point]);
  Address:=TruncateAddr(Address)+Masyamba+ExtractWord(1,s,[Point]);
  s:=UpStr(ExtractWord(6,s,[Point]));
  if (s=UpStr(StrPas(bfHold))) then flavor:=ofHold else
  if (s=UpStr(StrPas(bfDirect))) then flavor:=ofDirect else
  if (s=UpStr(StrPas(bfCrash))) then flavor:=ofCrash else
  if (s=UpStr(StrPas(bfNormal))) then flavor:=ofNormal else
  if (s=UpStr(StrPas(bfImmediate))) then flavor:=ofImmediate else flavor:=ofNormal;
 end;
{}
procedure tLongBSO.Addr2Name;
 var
  di: pDomainInfo;
  i: Integer;
 begin
  FileName:=ExtractWord(1,Address,FidoChars)+Point+ExtractWord(2,Address,FidoChars)+Point+
            ExtractWord(3,Address,FidoChars)+Point;
  if (CToN(ExtractWord(4,Address,FidoChars))<>0) then FileName:=FileName+ExtractWord(4,Address,FidoChars)
  else FileName:=FileName+'0';
  FileName:=FileName+Point;
  case flavor of
   ofHold: FileName:=FileName+StrPas(bfHold);
   ofDirect: FileName:=FileName+StrPas(bfDirect);
   ofCrash: FileName:=FileName+StrPas(bfCrash);
   ofNormal: FileName:=FileName+StrPas(bfNormal);
   ofImmediate: FileName:=FileName+StrPas(bfImmediate);
  end;
  New(di,Init(CToN(ExtractWord(1,Address,FidoChars)),''));
  if (not ZoneDomains^.Search(di,i)) then
   begin
    FileName:=StrPas(bfAsshole)+Point+FileName;
    DisposeObj(di);
   end
  else
   begin
    DisposeObj(di);
    di:=ZoneDomains^.At(i);
    FileName:=GetPS(di^.Domain)+Point+FileName;
   end;
  FileName:=GetPS(RootDir)+FileName;
 end;
{}
procedure tLongBSO.CopyFile;
 var
  queueDir,bsoName: String;
  f: pStream;
 begin
  if (not Exist(FileName)) then exit;
  Addr2Name(Address,Flavor,bsoName);
  bsoName:=bsoName+Point+StrPas(lbsoList);
  MkTree(bsoName);
  queueDir:=AddBackSlash(JustPathName(RemoveBackSlash(GetPS(RootDir))))+StrPas(dirQueue);
  MkTree(queueDir);
  if (not Exist(queueDir+JustFileName(FileName))) then rCommon.CopyFile(FileName,queueDir+JustFileName(FileName),false);
  if (not Exist(bsoName)) then f:=New(pBufStream,Init(bsoName,stCreate or stDenyWrite ,BlockSize))
  else f:=New(pBufStream,Init(bsoName,stOpenWrite or stDenyWrite,BlockSize));
  f^.Seek(f^.GetSize);
  StreamWriteLn(f^,queueDir+JustFileName(FileName),cr+lf);
  DisposeObj(f);
 end;
{}
procedure tLongBSO.MoveFile;
 var
  queueDir,bsoName: String;
  f: pStream;
 begin
  if (not Exist(FileName)) then exit;
  Addr2Name(Address,Flavor,bsoName);
  bsoName:=bsoName+Point+StrPas(lbsoList);
  MkTree(bsoName);
  queueDir:=AddBackSlash(JustPathName(RemoveBackSlash(GetPS(RootDir))))+StrPas(dirQueue);
  MkTree(queueDir);
  if (not Exist(queueDir+JustFileName(FileName))) then rCommon.MoveFile(FileName,queueDir+JustFileName(FileName))
  else KillFile(FileName);
  if (not Exist(bsoName)) then f:=New(pBufStream,Init(bsoName,stCreate or stDenyWrite ,BlockSize))
  else f:=New(pBufStream,Init(bsoName,stOpenWrite or stDenyWrite,BlockSize));
  f^.Seek(f^.GetSize);
  StreamWriteLn(f^,queueDir+JustFileName(FileName),cr+lf);
  DisposeObj(f);
 end;
{}
procedure tLongBSO.AttachFile;
 var
  bsoName: String;
  f: pStream;
 begin
  if (not Exist(FileName)) then exit;
  Addr2Name(Address,Flavor,bsoName);
  bsoName:=bsoName+Point+StrPas(lbsoList);
  if (not Exist(bsoName)) then f:=New(pBufStream,Init(bsoName,stCreate or stDenyWrite ,BlockSize))
  else f:=New(pBufStream,Init(bsoName,stOpenWrite or stDenyWrite,BlockSize));
  f^.Seek(f^.GetSize);
  case FileType of
   ftKillSent: StreamWriteLn(f^,'^','');
   ftTruncateSent: StreamWriteLn(f^,'#','');
  end;
  StreamWriteLn(f^,FileName,cr+lf);
  DisposeObj(f);
 end;
{}
procedure tLongBSO.CleanQueue;
 var
  sr: SearchRec;
  Files: pStrLines;
  bsoFiles: pStringCollection;
  lc: pLinkCollection;
  fc: pLinkFileCollection;
  s,QueueDir: String;
  x,y,i: Integer;
 begin
  QueueDir:=AddBackSlash(JustPathName(RemoveBackSlash(GetPS(RootDir))))+StrPas(dirQueue);
  FindFirst(QueueDir+x_x,AnyFile,sr);
  while (DosError=0) and ((sr.Name=Point) or (sr.Name=Point+Point)) do Dos.FindNext(sr);
  New(Files,Init(16,16));
  while (DosError=0) do
   begin
    if ((sr.Attr and Directory)=0) and
       ((sr.Attr and VolumeID)=0) then Files^.Insert(NewStr(UpStr(sr.Name)));
    FindNext(sr);
   end;
  New(lc,Init(16,16));
  New(fc,Init(16,16));
  New(bsoFiles,Init(16,16));
  bsoFiles^.Duplicates:=False;
  GetLinks(lc^);
  with (lc^) do if (Count>0) then for x:=0 to Count-1 do
   begin
    GetFiles(pLink(At(x))^,fc^);
    with (fc^) do if (Count>0) then for y:=0 to Count-1 do
    with (pLinkFile(At(y))^) do if (UpStr(QueueDir)=UpStr(GetPS(FileDir))) then
     begin
      s:=UpStr(UpStr(GetPS(FileName)));
      if (not bsoFiles^.Search(@s,i)) then bsoFiles^.Insert(NewStr(s));
     end;
   end;
  with (Files^) do if (Count>0) then for x:=0 to Count-1 do if (not bsoFiles^.Search(At(x),y)) then
  KillFile(QueueDir+GetPS(At(x)));
{$IfDef VirtualPascal}
  FindClose(sr);
{$EndIf}

  DisposeObj(Files);
  DisposeObj(bsoFiles);
  DisposeObj(lc);
  DisposeObj(fc);
 end;
{}
function tLongBSO.StoreMessage;
 var
  bsoName: String;
  Pkt: pPktBase;
  x: Word;
 begin
  StoreMessage:=1;
  if (@Msg=nil) then exit;
  if (Msg.MsgStatus=msEmpty) then exit;
  Addr2Name(Address,Flavor,bsoName);
  bsoName:=bsoName+Point+StrPas(lbsoMail);

  New(Pkt,Init);
  Pkt^.PktHdr.PVMajOr:=hVer;
  Pkt^.PktHdr.PVMinor:=lVer;
  Pkt^.PktHdr.PrdCodL:=FSCProd;
  if Exist(bsoName) then
   begin
    ReallocStr(Pkt^.BaseFileName,bsoName);
    Pkt^.MainLink:=New(pBufStream,Init(GetPS(Pkt^.BaseFileName),stOpen,BlockSize));
    Pkt^.BaseStatus:=bsOpened;
   end;
  if Pkt^.BaseStatus<>bsOpened then with Pkt^ do
   begin
    SetSourceAddress(SourceAddress);
    SetDestinationAddress(Address);
    SetPassWord(Password);
    SaveBaseHdr(bsoName,stDenyNone);
   end;
  with Pkt^ do
   begin
    x:=Pkt^.MainLink^.Status;
    DisposeObj(Kills);
    DisposeObj(Coords);
    DisposeObj(MainLink);
   end;
  ReallocStr(Pkt^.BaseFileName,'');
  Dispose(Pkt,Dummy);
  if (x<>0) then exit;
  FastPktSave(bsoName,Msg);
  StoreMessage:=0;
 end;
{}
function tLongBSO.LinkBusy;
 var
  bsoName: String;
 begin
  Addr2Name(Addr,ofCrash,bsoName);
  bsoName:=ForceExtension(bsoName,StrPas(lbsoBusy));
  LinkBusy:=(Exist(bsoName));
 end;
{}
function tLongBSO.AddFreq;
 var
  bsoName: String;
  t: Text;
 begin
  AddFreq:=1;
  Addr2Name(Addr,ofCrash,bsoName);
  bsoName:=ForceExtension(bsoName,StrPas(lbsoRequ));
  if (not MkTree(bsoName)) then exit;
  Assign(t,bsoName);
  if Exist(bsoName) then Append(t) else Rewrite(t);
  WriteLn(t,FileName);
  Close(t);
  AddFreq:=0;
 end;
{}
end.
